function u = CoalVal(C,params)
% u = CoalVal(C,params)
%
% <C> contains the identifiers of the agents 
% <params> is a cell array containing the parameters 
% <u> is the value of the coalition
%
% Note: in the workspace, it is needed to declare as global all the
% variables which are needed by the function CoalVal (e.g. correspondence
% between agents and identifiers, tables, etc etc -- see the DEMO file)
% 
% IMPORTANT NOTE: please rename the file name as CoalVal.m before using it

pf = params{1};
pda = params{2};
Kpow = params{3};

% this function use the variable <profiles> which should be declared as
% global in the main workspace
global profiles;
if ~exist('profiles')
    fprintf('Not able to access the Energy profiles\n');
    u = 0;
    return
end

% replace identifiers with profiles
C = profiles(C,:);

% now compute the characteristic function
l = size(C,1);
E = sum(C,1);
es=sort(E,'descend');
m=length(E);
B=es(floor(47*pf/pda )+1);
base=B*m;
f=base*pf;
peak= sum((es-B).*((es-B)>0));
d=peak*pda;
K=l^Kpow;
u = -base*pf -peak*pda - K;